" Quit when a syntax file was already loaded.
if exists('b:current_syntax')
  finish
endif

syn case match

" section
syn keyword woprSection         section
hi def link woprSection         Structure

" data
syn keyword woprData            db dw
hi def link woprData            Structure

" labels
syn match   woprLabel           '\<\h\w*\>'
syn match   woprColon           /:/
hi def link woprLabel           Identifier
hi def link woprColon           Identifier

" instructions
syn keyword woprInstruction     nop push pop dup dup1 dup2 dup3 swap swap1 swap2 swap4 alloc load loadb lload lloadb ref refb load_pc load_es load_rs sto stob lsto lstob sref srefb sto_pc sto_es sto_rs add sub inc dec neg mul muls div divs mod and or xor not shl shls shr shrs jmp je jne jg jgs jl jls jz jnz jgzs jlzs call ret iret out halt
hi def link woprInstruction     Keyword

" comments
syn keyword woprTodo contained  TODO FIXME XXX NOTE
syn match   woprComment         ';.*$' contains=woprTodo
hi def link woprComment         Comment
hi def link woprTodo            Todo

" numbers
syn match   woprDecimalInt      "\<-\=\d\+\>"
syn match   woprHexadecimalInt  "\<0[xX]\x\+\>"
hi def link woprDecimalInt      Number
hi def link woprHexadecimalInt  Number

" Strings and their contents
syn region  woprString          start='"' end='"'
hi def link woprString          String

" register syntax name
let b:current_syntax = "wopr"
